image: "python:latest"

before_script:
    - pip install virtualenv
    - python -m virtualenv venv
    - source venv/bin/activate
    - pip install -r requirements.txt

stages:
    - Static Analysis
    - Test

pylint:
    stage: Static Analysis
    script:
        - pip install -r requirements.txt
        - pip install pylint pylint-exit
        - pylint --rcfile=.pylintrc ./basemesh/ || pylint-exit $?

pyright:
    stage: Static Analysis
    script:
        - pip install pyright qgis-stubs
        - pyright

unittest:
    stage: Test
    script:
        - pip install -r requirements.txt
        - python -m unittest discover -s ./tests/ -p "*_test.py"
